#!/usr/bin/perl -w

# Este script borra la ltima transaccin incompleta del fichero de log
# y borra su lock asociado

# $Id: borrarlock.pl,v 1.6 2003/07/10 19:19:37 jmcasanova Exp $

use strict;
use lib '/usr/lib/fisterra';
use common;

########################################################
# Nombre de la maquina cliente. Poner aqui la correcta
my $maquina=`hostname`;
chomp($maquina);
########################################################

my $md5sum; # Para comprobar que el fichero original no se modifica
my $fichero;
my $ficherotmp;
my @ficheros = <$dir_logs/*.log>;
my @lineas;
my $l;

if ($#ficheros < 0) {
	logmsg($maquina,"No hay fichero de log pendiente. Saliendo.");
	exit $EXIT_OK;
} elsif ($#ficheros > 0) {
	logmsg($maquina,"Error! Hay ms de un fichero de log.");
	exit $EXIT_MANYLOGS;
}

$fichero = $ficheros[0];
$md5sum = getmd5($fichero);
$ficherotmp = "$fichero.new";
if (!-f "$fichero.lock") {
	crear_lock("$fichero.lock");
}

open(ENTRADA,$fichero);
open(SALIDA,">$ficherotmp");

foreach $l (<ENTRADA>) {
	#print("$l");
	push @lineas,$l;
	if ($l =~ /^\s*End Transaction [01]\s*$/) {
		print SALIDA @lineas;
		@lineas = ();
	}
}

close(ENTRADA);
close(SALIDA);


if (getmd5($fichero) ne $md5sum) {
	logmsg($maquina,"El fichero de log ha sido cambiado!");
	exit $EXIT_BADMD5;
}


system("mv","-f","$fichero.new",$fichero);


borrar_lock("$fichero.lock");
#logmsg($maquina,"Finalizando...");

exit $EXIT_OK;
