#!/bin/sh
ERROR='0'

if  (! grep -sq "^[^#]*[tT][Cc][Pp][Ii][Pp]_[Ss][Oo][Cc][Kk][Ee][Tt].*=\ *\(true\|1\)" /etc/postgresql/postgresql.conf)
    then
    echo "POSTGRESQL CONF ERROR in  /etc/postgresql/postgresql.conf"
    echo
    echo "TCP/IP socked database connections should be allowed"
    echo "There should be a line like this in /etc/postgresql/postgresql.conf"
    echo 
    echo "tcpip_socket=true"
    echo
    ERROR=1
fi

if (! grep  "^[^#]*host.*127.[0-9]*.[0-9]*.[0-9]*" /etc/postgresql/pg_hba.conf| grep -sq -v "\(reject\|ident\)")
    then
    echo "POSTGRESQL CONF ERROR in /etc/postgresql/pg_hba.conf"
    echo 
    echo "Postgres connections should be allowed from localhost by tcpip"
    echo "A like similar to this should be in /etc/postgresql/pg_hba.conf"
    echo 
    echo "host    all         all         127.0.0.1         255.255.255.255   password"
    echo 
    echo "Fisterra runs with password, crypt, trust and md5 authentification modules"
    echo "Authentification mode shouldn't be ident or reject"
    echo "IMPORTANT : Just change this line begining with 'host'"
    echo "            another line begining with 'local' needs 'ident sameuser' method"

    ERROR=1
fi

if (! grep -sq  "^[^#]*local.*ident.*sameuser" /etc/postgresql/pg_hba.conf)
    then
    echo "POSTGRESQL CONF ERROR in /etc/postgresql/pg_hda.conf"
    echo 
    echo "Postgres connections should be allowed in localhost unix sockets"
    echo "A like similar to this should be in /etc/postgresql/pg_hda.conf"
    echo 
    echo "local    all                              ident sameuser"
    echo " "
    echo "This line is needed for instalation"

    ERROR=1
fi


if [ $ERROR != 0 ]
    then
    echo " "
    echo "To run fisterra please correct this problems in postgresql config."
    echo "Don't forget restarting postgresql with /etc/init.d/postgresql restart"
else
    echo "Postgresql configuration seems to be correct to run fisterra. Have Fun"
fi


exit $ERROR
